#include "device.h"
#include "utils/array.h"
#include "usb/usb.h"
#include <dlfcn.h>

struct DEVICE
{
    // Device driver
    void* driver;

    // Physical device handle
    void* handle;
};

array_t* device_array;

void device_init()
{
    device_array = array_alloc();
    usb_init();
}

array_t* device_get_array()
{
    return device_array;
}

device_t* device_register(void* driver, void* handle)
{
    device_t* tr = malloc(sizeof(device_t));
    tr->driver = driver;
    tr->handle = handle;

    array_add(device_array, tr);

    return tr;
}

char* device_get_image(device_t* device)
{
    char* (*getimage_fn)(void*) = dlsym(device->driver, "driver_get_image");
    return getimage_fn(device->handle);
}

char* device_get_name(device_t* device)
{
    char* (*getname_fn)(void*) = dlsym(device->driver, "driver_get_name");
    return getname_fn(device->handle);
}
