#pragma once

#include <adwaita.h>

G_DECLARE_DERIVABLE_TYPE(Panel, panel, GINPUT, PANEL, AdwBin)

G_BEGIN_DECLS

/**
 * PanelClass:
 *
 * The contents of this struct are private and should not be accessed directly.
 */
struct _PanelClass
{
	/*< private >*/
	AdwBinClass parent_class;

	const gchar* (*get_help_uri)(Panel* panel);

	GtkWidget* (*get_sidebar_widget)(Panel* panel);
};

GPermission* panel_get_permission(Panel* panel);

const gchar* panel_get_help_uri(Panel* panel);

GtkWidget* panel_get_sidebar_widget(Panel* panel);

GCancellable* panel_get_cancellable(Panel* panel);

gboolean panel_get_folded(Panel* panel);

GtkWidget* panel_get_content(Panel* panel);

void panel_set_content(Panel* panel, GtkWidget* content);

GtkWidget* panel_get_titlebar(Panel* panel);

void panel_set_titlebar(Panel* panel, GtkWidget* titlebar);

void panel_deactivate(Panel* panel);

G_END_DECLS
